#include <sys/cdefs.h>

#include <stdio.h>

#include <test.h>
#include "internal.h"
#include "test_compat.h"

#define	VERSION	"2.0"

//HIDDEN
__attribute__((visibility("hidden")))
int one = 1;

//COMPATSYMVAR(i_v0_0,i,TEST_0.0)
__asm(".symver i_v0_0,i@TEST_0.0");
__attribute__((visibility("default")))
int
i_v0_0(int y, int d)
{
	printf("%s %s:%d i_int(%x, %d)\n", VERSION, __FILE__, __LINE__, y, d);
	return y + d;
}

//COMPATSYMVER(f,f_v0_0,TEST_0.0)
__asm(".symver f_v0_0,f@TEST_0.0");
__attribute__((visibility("default")))
int
f_v0_0(int x)
{
	printf("%s %s:%d f_int(%x)\n", VERSION, __FILE__, __LINE__, x);
	return i_v0_0(x << 8, one);
}

//HIDDEN
__attribute__((visibility("hidden")))
long
i(long y, long d)
{
	printf("%s %s:%d i_long(%lx, %ld)\n", VERSION, __FILE__, __LINE__, y, d);
	return y + d;
}

//DEFAULTSYMVER(f,f_v2_0,TEST_2.0)
__typeof(f) f_v2_0;
__asm(".symver f_v2_0,f@@TEST_2.0");
__attribute__((visibility("default")))
long
f_v2_0(long x)
{
	printf("%s %s:%d f_long(%lx)\n", VERSION, __FILE__, __LINE__, x);
	return i(x << 8, 1);
}

//HIDDEN
__attribute__((visibility("hidden")))
long
h(long x)
{
	printf("%s %s:%d h_long(%lx)\n", VERSION, __FILE__, __LINE__, x);
	return x >> 8;
}

//EXPORT
__attribute__((visibility("default")))
int
g(int x)
{
	printf("%s %s:%d g(%x)\n", VERSION, __FILE__, __LINE__, x);
	return h(f(x));
}
